// cc -o myrects -l ncurses myrects.c

#include <ncurses.h>

// These numbers will be inserted wherever RED or GREEN appear
// It just makes the code easier to read.
#define RED     1
#define GREEN   2
#define BLUE    3 
#define YELLOW  4 

// This describes the arguments for a function we will define below
int fillRect(char c, int color, int startx, int starty, int width, int height);

int main(){
     initscr();

     clear();
	 start_color();  /* Start color */
	 // here we allocate our colors, and set the fall-back color to be black
     init_pair(1, COLOR_RED, COLOR_BLACK);
     init_pair(2, COLOR_GREEN, COLOR_BLACK);
     init_pair(3, COLOR_BLUE, COLOR_BLACK);
     init_pair(4, COLOR_YELLOW, COLOR_BLACK);

     fillRect('d', RED, 1, 1, 10, 1);
     fillRect('x', YELLOW, 30, 30, 40, 10);
     fillRect('Q', BLUE, 10, 10, 20, 10);
     fillRect('Y', GREEN, 50, 1, 100, 100);



     refresh();
     sleep(5);

     // Clean up
     endwin();
}

// A subroutine (function) for drawing rectangles.
int fillRect(char c, int color, int startx, int starty, int width, int height){
	int x, y;

    attron(COLOR_PAIR(color));
	for(x=startx;x<(startx+width);x++){
	  for(y=starty;y<(starty+width);y++){
          mvaddch(y,x,c);
	  }
	}
    attroff(COLOR_PAIR(color));
}
